/* Copyright (C) 1998-2000  Matthes Bender  RedWolf Design */

/* Scan ini-type text component files to run-time data structures */

#ifndef INC_C4Compiler
#define INC_C4Compiler

const int32_t C4CV_String			= 1,
					C4CV_Id					= 2,
					C4CV_Integer		= 3,
					C4CV_Fixed			= 4,
					C4CV_NameList		= 5,
					C4CV_IdList			= 6,
					C4CV_ObjectList	= 7,
					C4CV_ValueList	= 8,
					C4CV_ValueMap		= 9,
					C4CV_OldColor		= 10,
					C4CV_DefGraphics= 11,
					C4CV_Transform  = 12,
					C4CV_StringPtr  = 13,
					C4CV_EffectList = 14,
					C4CV_GfxOverlayList = 15,

					C4CV_Section		= 101,
					C4CV_Ignore 		= 102,
					C4CV_End				= 0;

const long C4EnumPointer1 = 1000000000,
					C4EnumPointer2 = 1001000000;

#ifndef offsetof
#define offsetof(s,m)	(size_t)&(((s *)0)->m)
#endif

class C4CompilerValue 
	{ 
	public:
		char *Name;
    int32_t Type;
    int32_t Offset;
    int32_t Size;
  };

// callback function type for dynamic structure compiling
typedef bool (*C4CompileStructureCallback)(const char *, void *&, C4CompilerValue *&);

class C4Compiler
	{
	public:
		BOOL CompileStructure(C4CompilerValue *pRefs, const char *szSource, void *vpTarget, const char *szSecExt=NULL, const char *szLanguage=NULL, C4CompileStructureCallback pfnCallback=NULL, int32_t iSectionMask=0);
		BOOL DecompileStructure(C4CompilerValue *pRefs, void *vpData, void *vpDefault, char **ppOutput, size_t *ipSize, const char *szSecExt=NULL, int32_t iSectionMask=0);
	protected:
		BOOL CompileLine(C4CompilerValue *pRefs, const char *szSection, const char *szLine, BYTE *pTarget, const char *szSecExt, const char *szLanguage=NULL, int32_t iSectionMask=0);
	};

#endif
