// Simple C4MaterialMap for use with standalone C4MapCreatorS2

#ifndef INC_C4MAPCREATORS2_C4MATERIAL_H
#define INC_C4MAPCREATORS2_C4MATERIAL_H

#include <C4Group.h>
#include <C4Constants.h>
#include <Standard.h>

class C4Material
{
	friend class C4MaterialMap;
public:
	char Name[C4M_MaxName + 1];
	uint32_t Color[C4M_ColsPerMat*3];

protected:
	void Compile(const char* file, const char* source);
	void Load(C4Group& hGroup, const char* entryname);
};

class C4MaterialMap
{
public:
  C4MaterialMap(C4Group& hGroup, C4Group* OverloadFile);
  ~C4MaterialMap();

  int32_t Get(const char* mat_name);

  int32_t Num;
  C4Material* Map;

protected:
  void load_group(C4Group& hGroup, C4Group* OverloadFile);
};

const int32_t MNone = -1; // undefined material

#endif // INC_C4MAPCREATORS2_C4MATERIAL_H
